#include <gccore.h>
#include <stdio.h>
#include <unistd.h>
#include <malloc.h>
#include <string.h>
#include <fat.h>
#include <sdcard/gcsd.h>

/*
// make sure thats updated with new args
#define NUM_ARGS 5
// note: first arg gets ignored by GBI because its the start path
const char *GBIArgs[NUM_ARGS] = { "/", "--offset=0:2", "--zoom=3.25", "--format=pal60", "--nointerlaced" };
*/

/*
static void *xfb = NULL;
static GXRModeObj *rmode = NULL;

void *Initialise();
void (*PSOreload)() = (void(*)())0x80001800;
void * Initialise() {

	void *framebuffer;

	VIDEO_Init();
	PAD_Init();
	
	rmode = VIDEO_GetPreferredMode(NULL);

	framebuffer = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(framebuffer,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(framebuffer);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();

	return framebuffer;

}
*/

typedef struct _dolheader {
	u32 text_pos[7];
	u32 data_pos[11];
	u32 text_start[7];
	u32 data_start[11];
	u32 text_size[7];
	u32 data_size[11];
	u32 bss_start;
	u32 bss_size;
	u32 entry_point;
} dolheader;

typedef void (*entrypoint) (void);

static int initFAT(){

	int slotagecko = 0;
	int i =0;
	s32 ret, memsize, sectsize;


	for(i=0;i<10;i++){
		ret = CARD_ProbeEx(CARD_SLOTA, &memsize, &sectsize);
		//printf("Ret: %d", ret);
		if (ret == CARD_ERROR_WRONGDEVICE){
			slotagecko = 1;
			break;
		}
	}

	if (slotagecko)
	{//Memcard in SLOT B, SD gecko in SLOT A
		//This will ensure SD gecko is recognized if inserted or changed to another slot after GCMM is executed
		for(i=0;i<10;i++){
			ret = CARD_Probe(CARD_SLOTA);
			if (ret == CARD_ERROR_WRONGDEVICE)
				//printf ("SDGecko detected...\n\n");
				break;
		}
		__io_gcsda.startup();
		if (!__io_gcsda.isInserted())
		{
			//printf ("No SD Gecko inserted! Using embedded config.\n\n");
			return 0;
		}
		if (!fatMountSimple ("fat", &__io_gcsda))
		{
			//printf("Error Mounting SD fat! Using embedded config.\n\n");
			return 0;
		}
	}else //Memcard in SLOT A, SD gecko in SLOT B
	{
		//This will ensure SD gecko is recognized if inserted or changed to another slot after GCMM is executed
		for(i=0;i<10;i++){
			ret = CARD_Probe(CARD_SLOTB);
			if (ret == CARD_ERROR_WRONGDEVICE)
				break;
		}	
		__io_gcsdb.startup();
		if (!__io_gcsdb.isInserted())
		{
			//printf ("No SD Gecko inserted! Using default config.\n\n");
			return 0;
		}
		if (!fatMountSimple ("fat", &__io_gcsdb))
		{
			//printf("Error Mounting SD fat! Using default config.\n\n");
			return 0;
		}
	}

	return 1;
}

int main(int argc, char *argv[])
{
	//does more than it should
	VIDEO_Init();
	//Initialise();

/*
	while(1) {

		VIDEO_WaitVSync();
		PAD_ScanPads();

		int buttonsDown = PAD_ButtonsDown(0);
		
		if( buttonsDown & PAD_BUTTON_A ) {
			printf("Press A to load.\n");
		}

		if (buttonsDown & PAD_BUTTON_START) {
			PSOreload();
			break;
		}
	}
*/
	FILE * pFile;
	long lSize;
	char * dolbuffer;
	//size_t result;

	//printf("Mounting fat...");

	int have_sd = initFAT();
	if (have_sd){
		//printf ("success! Booting autoexec.dol...");

		pFile = fopen ( "fat:/autoexec.dol" , "rb" );
		//if (pFile==NULL) {printf ("Failed to open autoexec.dol");}

		// obtain file size:
		fseek (pFile , 0 , SEEK_END);
		lSize = ftell (pFile);
		rewind (pFile);

		// allocate memory to contain the whole file:
		dolbuffer = (char*) malloc (sizeof(char)*lSize);
		//if (dolbuffer == NULL) {printf ("Memory error");}

		// copy the file into the buffer:
		fread (dolbuffer,1,lSize,pFile);
		//result = fread (dolbuffer,1,lSize,pFile);
		//if (result != lSize) {printf ("Error reading autoexec.dol");}

		/* the whole file is now loaded in the memory buffer. */

		// terminate
		fclose (pFile);
	}

	u32 i;
	dolheader *dolfile = (dolheader*)dolbuffer;

	for (i = 0; i < 7; i++)
	{
		if ((!dolfile->text_size[i]) || (dolfile->text_start[i] < 0x100))
			continue;
		size_t size = dolfile->text_size[i];
		u8 *buf = (u8*)dolfile->text_start[i];
		memcpy(buf, dolbuffer + dolfile->text_pos[i], size);
		DCFlushRange(buf, size);
		ICInvalidateRange(buf, size);
	}

	for (i = 0; i < 11; i++)
	{
		if ((!dolfile->data_size[i]) || (dolfile->data_start[i] < 0x100))
			continue;
		size_t size = dolfile->data_size[i];
		u8 *buf = (u8*)dolfile->data_start[i];
		memcpy(buf, dolbuffer + dolfile->data_pos[i], size);
		DCFlushRange(buf, size);
		ICInvalidateRange(buf, size);
	}
	if (dolbuffer != NULL) free(dolbuffer);
/*
	struct __argv *dolArgs = (struct __argv*)(dolfile->entry_point+8);
	//init args struct
	dolArgs->argvMagic = ARGV_MAGIC;
	dolArgs->argc = NUM_ARGS;
	dolArgs->length = 1; //for 0 terminator

	for(i = 0; i < NUM_ARGS; ++i)
	{
		size_t cArgLen = strlen(GBIArgs[i])+1;
		dolArgs->length += cArgLen;
	}
	dolArgs->commandLine = malloc(dolArgs->length); //upper mem1, safe
	DCStoreRange(dolArgs, sizeof(struct __argv));

	u32 position = 0;
	for(i = 0; i < NUM_ARGS; ++i)
	{
		size_t cArgLen = strlen(GBIArgs[i])+1;
		memcpy(dolArgs->commandLine + position, GBIArgs[i], cArgLen);
		position += cArgLen;
	}
	dolArgs->commandLine[dolArgs->length-1] = '\0';
	DCStoreRange(dolArgs->commandLine, dolArgs->length);
*/
	VIDEO_WaitVSync();
	VIDEO_WaitVSync();
	SYS_ResetSystem(SYS_SHUTDOWN,0,0);
	entrypoint entry = (entrypoint)dolfile->entry_point;
	entry();

	return 0;
}
